package cn.ibizlab.humanresource.core.base.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.base.domain.HROperationUnit;
import cn.ibizlab.humanresource.core.base.filter.HROperationUnitSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HROperationUnit] 服务对象接口
 */
public interface IHROperationUnitService extends IService<HROperationUnit>{

    boolean create(HROperationUnit et) ;
    void createBatch(List<HROperationUnit> list) ;
    boolean update(HROperationUnit et) ;
    void updateBatch(List<HROperationUnit> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HROperationUnit get(String key) ;
    HROperationUnit getDraft(HROperationUnit et) ;
    boolean checkKey(HROperationUnit et) ;
    boolean save(HROperationUnit et) ;
    void saveBatch(List<HROperationUnit> list) ;
    Page<HROperationUnit> searchDefault(HROperationUnitSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HROperationUnit> getHroperationunitByIds(List<String> ids) ;
    List<HROperationUnit> getHroperationunitByEntities(List<HROperationUnit> entities) ;
}


